#ifndef OPTION_ASDL_H
#define OPTION_ASDL_H

namespace option_asdl {

#define ASDL_NAMES struct
ASDL_NAMES option_i {
  enum no_name {
  errexit = 1,
  nounset = 2,
  pipefail = 3,
  inherit_errexit = 4,
  nullglob = 5,
  verbose_errexit = 6,
  noexec = 7,
  xtrace = 8,
  verbose = 9,
  noglob = 10,
  noclobber = 11,
  errtrace = 12,
  posix = 13,
  vi = 14,
  emacs = 15,
  interactive = 16,
  hashall = 17,
  lastpipe = 18,
  failglob = 19,
  extglob = 20,
  nocasematch = 21,
  dotglob = 22,
  extdebug = 23,
  eval_unsafe_arith = 24,
  ignore_flags_not_impl = 25,
  ignore_shopt_not_impl = 26,
  _allow_command_sub = 27,
  _allow_process_sub = 28,
  dynamic_scope = 29,
  redefine_const = 30,
  redefine_source = 31,
  _running_trap = 32,
  _running_hay = 33,
  _no_debug_trap = 34,
  _no_err_trap = 35,
  strict_parse_slice = 36,
  strict_argv = 37,
  strict_arith = 38,
  strict_array = 39,
  strict_control_flow = 40,
  strict_errexit = 41,
  strict_nameref = 42,
  strict_word_eval = 43,
  strict_tilde = 44,
  strict_glob = 45,
  parse_at = 46,
  parse_proc = 47,
  parse_func = 48,
  parse_brace = 49,
  parse_bracket = 50,
  parse_equals = 51,
  parse_paren = 52,
  parse_ysh_string = 53,
  parse_triple_quote = 54,
  simple_word_eval = 55,
  dashglob = 56,
  command_sub_errexit = 57,
  process_sub_fail = 58,
  xtrace_rich = 59,
  xtrace_details = 60,
  sigpipe_status_ok = 61,
  env_obj = 62,
  for_loop_frames = 63,
  parse_at_all = 64,
  parse_backslash = 65,
  parse_backticks = 66,
  parse_dollar = 67,
  parse_ignored = 68,
  parse_sh_arith = 69,
  parse_dparen = 70,
  parse_dbracket = 71,
  parse_bare_word = 72,
  no_exported = 73,
  no_init_globals = 74,
  simple_echo = 75,
  simple_eval_builtin = 76,
  simple_test_builtin = 77,
  expand_aliases = 78,
  progcomp = 79,
  histappend = 80,
  hostcomplete = 81,
  cmdhist = 82,
  assoc_expand_once = 83,
  autocd = 84,
  cdable_vars = 85,
  cdspell = 86,
  checkhash = 87,
  checkjobs = 88,
  checkwinsize = 89,
  complete_fullquote = 90,
  direxpand = 91,
  dirspell = 92,
  execfail = 93,
  extquote = 94,
  force_fignore = 95,
  globasciiranges = 96,
  globstar = 97,
  gnu_errfmt = 98,
  histreedit = 99,
  histverify = 100,
  huponexit = 101,
  interactive_comments = 102,
  lithist = 103,
  localvar_inherit = 104,
  localvar_unset = 105,
  login_shell = 106,
  mailwarn = 107,
  no_empty_cmd_completion = 108,
  nocaseglob = 109,
  progcomp_alias = 110,
  promptvars = 111,
  restricted_shell = 112,
  shift_verbose = 113,
  sourcepath = 114,
  xpg_echo = 115,
  ARRAY_SIZE = 116,
  };
};

typedef int option_t;

ASDL_NAMES builtin_i {
  enum no_name {
  colon = 1,
  dot = 2,
  exec_ = 3,
  eval = 4,
  set = 5,
  shift = 6,
  times = 7,
  trap = 8,
  unset = 9,
  readonly = 10,
  local = 11,
  declare = 12,
  typeset = 13,
  export_ = 14,
  extern_ = 15,
  true_ = 16,
  false_ = 17,
  try_ = 18,
  assert_ = 19,
  read = 20,
  echo = 21,
  printf = 22,
  mapfile = 23,
  readarray = 24,
  cd = 25,
  pushd = 26,
  popd = 27,
  dirs = 28,
  pwd = 29,
  source = 30,
  umask = 31,
  ulimit = 32,
  wait = 33,
  jobs = 34,
  fg = 35,
  bg = 36,
  shopt = 37,
  complete = 38,
  compgen = 39,
  compopt = 40,
  compadjust = 41,
  compexport = 42,
  getopts = 43,
  builtin = 44,
  command = 45,
  type = 46,
  hash = 47,
  help = 48,
  history = 49,
  alias = 50,
  unalias = 51,
  bind = 52,
  append = 53,
  write = 54,
  json = 55,
  json8 = 56,
  pp = 57,
  hay = 58,
  haynode = 59,
  use = 60,
  error = 61,
  failed = 62,
  fork = 63,
  forkwait = 64,
  redir = 65,
  fopen = 66,
  shvar = 67,
  ctx = 68,
  invoke = 69,
  runproc = 70,
  boolstatus = 71,
  test = 72,
  bracket = 73,
  push_registers = 74,
  source_guard = 75,
  is_main = 76,
  cat = 77,
  ARRAY_SIZE = 78,
  };
};

typedef int builtin_t;


}  // namespace option_asdl

#endif  // OPTION_ASDL_H
